/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.muni.fi.pb138.xquerydemo;

import java.io.FileReader;
import java.io.IOException;
import java.util.Properties;
import javax.xml.transform.OutputKeys;
import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.stream.StreamSource;
import net.sf.saxon.Configuration;
import net.sf.saxon.om.DocumentInfo;
import net.sf.saxon.om.SequenceIterator;
import net.sf.saxon.query.DynamicQueryContext;
import net.sf.saxon.query.QueryResult;
import net.sf.saxon.query.StaticQueryContext;
import net.sf.saxon.query.XQueryExpression;
import net.sf.saxon.trans.XPathException;

/**
 *
 * @author tomp
 */
public class Main {

    /**
     * Running a simple query using Saxon 9 API
     * For more examples, see
     * http://www.saxonica.com/documentation/using-xquery/api-query/embedding.xml
     */
    public static void main(String[] args) throws XPathException, IOException {

        Configuration config = new Configuration();

        StaticQueryContext staticContext = config.newStaticQueryContext();

        XQueryExpression exp = staticContext.compileQuery(new FileReader("query12.xq"));

        DynamicQueryContext dynamicContext =
                new DynamicQueryContext(config);

        dynamicContext.setContextItem(config.buildDocument(new StreamSource("file:prices.xml")));

        dynamicContext.setParameter("title", "TCP/IP Illustrated");

        SequenceIterator books = exp.iterator(dynamicContext);

        DocumentInfo resultDoc = QueryResult.wrap(books, config);
        
        Properties props = new Properties();
        props.setProperty(OutputKeys.METHOD, "xml");
        props.setProperty(OutputKeys.INDENT, "yes");

        QueryResult.serialize(resultDoc,
                new StreamResult(System.out), props);


//        NodeInfo surname = (NodeInfo) surnames.next();
//        while (surname != null) {
//            String surnameText = surname.getStringValue();
//            System.out.println(surnameText);
//            surname = (NodeInfo) surnames.next();
//        }
    }
}
